2 # $NetBSD: checkver,v 1.12 2000/07/22 16:04:57 erh Exp $
4 # Copyright (c) 1998 The NetBSD Foundation, Inc.
7 # This code is derived from software contributed to The NetBSD Foundation
8 # by Eric Haszlakiewicz.
10 # Redistribution and use in source and binary forms, with or without
11 # modification, are permitted provided that the following conditions
13 # 1. Redistributions of source code must retain the above copyright
14 # notice, this list of conditions and the following disclaimer.
15 # 2. Redistributions in binary form must reproduce the above copyright
16 # notice, this list of conditions and the following disclaimer in the
17 # documentation and/or other materials provided with the distribution.
19 # THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
20 # ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
21 # TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
22 # PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
23 # BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
24 # CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
25 # SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
26 # INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
27 # CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
28 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
29 # POSSIBILITY OF SUCH DAMAGE.
32 #--------------------------------------------------------------------#
34 # Check for libraries that appear to be newer than the
35 # one we're about to install.
37 # checkver [-q] [-v shlib_version_file] -d [installedlibdir [library name]]"
38 # checkver [-q] [-v shlib_version_file] -s [setlistdir [library name]]"
39 # checkver [-q] [-v shlib_version_file] -f liblistfile [library name]"
41 # One of -d, -s or -f must be specified.
43 # all: If library name is not specified it is assumed to
44 # be the name of the current directory.
46 # -d: Checks the version against the installed libraries.
47 # If no further arguments are given "/usr/lib" is
48 # used as the location of installed libraries.
50 # -s: Checks the version against the sets. If no argument
51 # follows the sets directory defaults to "/usr/src/distrib/sets/lists".
52 # The directory may be specified as either the top of the
53 # source tree or as the lists directory.
55 # -f: Checks the version against the provided list. A filename
58 # -v: Specify the filename of the shlib_version file. Defaults
59 # to "./shlib_version".
61 # This script produces no output if all library version are not
62 # large than the source version. If an installed library with a
63 # version greater than the source is found, checkver prints a
64 # header and a list of the names of the offending installed libraries.
66 # The header may be supressed by passing "-q" as the first argument.
70 # Can't trap 11 (SEGV) in the Real Bourne Shell, since it uses it for
72 trap "exit 2" 1 2 3 4 5 6 7 8 10 12 13 14 15
73 trap "[ -d $TMP ] && rm -rf $TMP" 0
76 echo "Usage: $1 [-q] [-v version_file] -d [installedlibdir [library name]]"
77 echo " $1 [-q] [-v version_file] -s [setlistdir [library name]]"
78 echo " $1 [-q] [-v version_file] -f liblistfile [library name]"
79 echo " $1 is a script that looks for installed libraries with"
80 echo " versions greater than that in the version file."
81 echo " For more information, read the comments."
85 setsdir
=$basedir/distrib
/sets
/lists
87 shlib_version
=.
/shlib_version
95 args
=`getopt "df:shqv:" "$@"`
96 if [ $?
-ne 0 ] ; then
103 while [ ! -z "$1" ]; do
106 if [ $usefile -eq 1 -o $usesets -eq 1 ]; then
109 -f) usefile
=1 ; arg1
=$2 ; shift ; shift
110 if [ $usedir -eq 1 -o $usesets -eq 1 ]; then
113 -s) usesets
=1 ; shift
114 if [ $usedir -eq 1 -o $usefile -eq 1 ]; then
117 -v) shlib_version
=$2; shift ; shift ;;
118 -h) Usage
$0 ; exit 0;;
119 -q) quiet
=1 ; shift;;
124 if [ $usedir -eq 0 -a $usefile -eq 0 -a $usesets -eq 0 ] ; then
128 if [ $usefile -eq 1 ] ; then
133 echo "$0: Unable to create temp directory."
136 LIBLIST
=$TMP/libs.lst
139 # Build list from the installed libraries.
140 if [ $usedir -eq 1 ] ; then
141 if [ "X$1" != "X" ] ; then
144 for f
in $libdir ; do
146 done > $LIBLIST 2> /dev
/null
149 # Build list from set lists. Parameter may be either
150 # the "lists" directory or the top of the source tree.
151 if [ $usesets -eq 1 ] ; then
152 if [ "X$1" != "X" ] ; then
154 if [ -d "$setsdir/distrib/sets/lists" ] ; then
155 setsdir
="$setsdir/distrib/sets/lists"
159 cat */[a-z
]* |
grep '^./usr/lib/lib.*\.so\.[0-9][0-9]*\.[0-9][0-9]*' \
165 # The file $LIBLIST now contains a list of libraries.
168 if [ "X$2" = "X" ] ; then
169 makefile
=$CWD/Makefile
170 libname
=`grep '^LIB=' $makefile | sed -e 's/^LIB=[[:space:]]*//'`
172 # Assume the library name is the name of the current directory.
173 if [ -z $libname ]; then
174 libname
=`basename $CWD`
179 echo $libname |
grep "^lib" 1>&2 2> /dev
/null
181 libname
="lib$libname"
185 if [ ! -f $shlib_version ] ; then
186 echo "$0: unable to find $shlib_version"
190 # Grab major and minor numbers from the source.
193 if [ "X$minor" = "X" -o "X$major" = "X" ] ; then
194 echo "$0: $shlib_version doesn't contain the version."
198 # Find every shared object library with the same base name.
199 for instlib
in `grep $libname.so "$LIBLIST" ` ; do
200 # Grab the major and minor from the installed library.
201 instmajor
=`basename $instlib | awk 'BEGIN { FS="." } { print $3 } '`
202 instminor
=`basename $instlib | awk 'BEGIN { FS="." } { print $4 } '`
203 instteeny
=`basename $instlib | awk 'BEGIN { FS="." } { print $5 + 0 } '`
205 # If they're greater than the source, complain.
206 if [ "0$major" -eq "0$instmajor" ] ; then
207 if [ "0$minor" -eq "0$instminor" ] ; then
208 if [ "0$teeny" -lt "0$instteeny" ] ; then
209 if [ $error -eq 0 -a $quiet -eq 0 ]; then
210 echo -n "The following libraries have versions greater"
211 echo " than the source:"
213 echo $instlib > /dev
/stderr
216 elif [ "0$minor" -lt "0$instminor" ] ; then
217 if [ $error -eq 0 -a $quiet -eq 0 ]; then
218 echo -n "The following libraries have versions greater"
219 echo " than the source:"
221 echo $instlib > /dev
/stderr
224 elif [ "0$major" -lt "0$instmajor" ] ; then
225 if [ $error -eq 0 -a $quiet -eq 0 ] ; then
226 echo -n "The following libraries have versions greater"
227 echo " than the source:"
229 echo $instlib > /dev
/stderr